javax.jms

## Interface TopicSession

- All Superinterfaces:
    AutoCloseable, Runnable, Session

      public interface TopicSession
      extends Session

  A `TopicSession` object provides methods for creating `TopicPublisher`, `TopicSubscriber`, and `TemporaryTopic` objects. It also provides a method for deleting its client's durable subscribers.

  A `TopicSession` is used for creating Pub/Sub specific objects. In general, use the `Session` object, and use `TopicSession` only to support existing code. Using the `Session` object simplifies the programming model, and allows transactions to be used across the two messaging domains.

  A `TopicSession` cannot be used to create objects specific to the point-to-point domain. The following methods inherit from `Session`, but must throw an `IllegalStateException` if used from `TopicSession`:

  - `createBrowser`
  - `createQueue`
  - `createTemporaryQueue`
  Since:
    JMS 1.0
  See Also:
    `Session`, `Connection.createSession(boolean, int)`, `TopicConnection.createTopicSession(boolean, int)`, `XATopicSession.getTopicSession()`

- - ### Field Summary

    - ### Fields inherited from interface javax.jms.Session

      `AUTO_ACKNOWLEDGE, CLIENT_ACKNOWLEDGE, DUPS_OK_ACKNOWLEDGE, SESSION_TRANSACTED`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `TopicSubscriber` | `createDurableSubscriber(Topic topic, String name)` Creates an unshared durable subscription on the specified topic (if one does not already exist) and creates a consumer on that durable subscription.
    `TopicSubscriber` | `createDurableSubscriber(Topic topic, String name, String messageSelector, boolean noLocal)` Creates an unshared durable subscription on the specified topic (if one does not already exist), specifying a message selector and the `noLocal` parameter, and creates a consumer on that durable subscription.
    `TopicPublisher` | `createPublisher(Topic topic)` Creates a publisher for the specified topic.
    `TopicSubscriber` | `createSubscriber(Topic topic)` Creates a nondurable subscriber to the specified topic.
    `TopicSubscriber` | `createSubscriber(Topic topic, String messageSelector, boolean noLocal)` Creates a nondurable subscriber to the specified topic, using a message selector or specifying whether messages published by its own connection should be delivered to it.
    `TemporaryTopic` | `createTemporaryTopic()` Creates a `TemporaryTopic` object.
    `Topic` | `createTopic(String topicName)` Creates a topic identity given a `Topic` name.
    `void` | `unsubscribe(String name)` Unsubscribes a durable subscription that has been created by a client.

    - ### Methods inherited from interface javax.jms.Session

      `close, commit, createBrowser, createBrowser, createBytesMessage, createConsumer, createConsumer, createConsumer, createDurableConsumer, createDurableConsumer, createMapMessage, createMessage, createObjectMessage, createObjectMessage, createProducer, createQueue, createSharedConsumer, createSharedConsumer, createSharedDurableConsumer, createSharedDurableConsumer, createStreamMessage, createTemporaryQueue, createTextMessage, createTextMessage, getAcknowledgeMode, getMessageListener, getTransacted, recover, rollback, run, setMessageListener`

- - ### Method Detail

    - #### createTopic

          Topic createTopic(String topicName)
                            throws JMSException

      Creates a topic identity given a `Topic` name.

      This facility is provided for the rare cases where clients need to dynamically manipulate topic identity. This allows the creation of a topic identity with a provider-specific name. Clients that depend on this ability are not portable.

      Note that this method is not for creating the physical topic. The physical creation of topics is an administrative task and is not to be initiated by the JMS API. The one exception is the creation of temporary topics, which is accomplished with the `createTemporaryTopic` method.

      Specified by:
        `createTopic` in interface `Session`
      Parameters:
        `topicName` - the name of this `Topic`
      Returns:
        a `Topic` with the given name
      Throws:
        `JMSException` - if the session fails to create a topic due to some internal error.

    - #### createSubscriber

          TopicSubscriber createSubscriber(Topic topic)
                                           throws JMSException

      Creates a nondurable subscriber to the specified topic.

      A client uses a `TopicSubscriber` object to receive messages that have been published to a topic.

      Regular `TopicSubscriber` objects are not durable. They receive only messages that are published while they are active.

      In some cases, a connection may both publish and subscribe to a topic. The subscriber `NoLocal` attribute allows a subscriber to inhibit the delivery of messages published by its own connection. The default value for this attribute is false.

      Parameters:
        `topic` - the `Topic` to subscribe to
      Throws:
        `JMSException` - if the session fails to create a subscriber due to some internal error.
        `InvalidDestinationException` - if an invalid topic is specified.

    - #### createSubscriber

          TopicSubscriber createSubscriber(Topic topic,
                                         String messageSelector,
                                         boolean noLocal)
                                           throws JMSException

      Creates a nondurable subscriber to the specified topic, using a message selector or specifying whether messages published by its own connection should be delivered to it.

      A client uses a `TopicSubscriber` object to receive messages that have been published to a topic.

      Regular `TopicSubscriber` objects are not durable. They receive only messages that are published while they are active.

      Messages filtered out by a subscriber's message selector will never be delivered to the subscriber. From the subscriber's perspective, they do not exist.

      In some cases, a connection may both publish and subscribe to a topic. The subscriber `NoLocal` attribute allows a subscriber to inhibit the delivery of messages published by its own connection. The default value for this attribute is false.

      Parameters:
        `topic` - the `Topic` to subscribe to
        `messageSelector` - only messages with properties matching the message selector expression are delivered. A value of null or an empty string indicates that there is no message selector for the message consumer.
        `noLocal` - if set, inhibits the delivery of messages published by its own connection
      Throws:
        `JMSException` - if the session fails to create a subscriber due to some internal error.
        `InvalidDestinationException` - if an invalid topic is specified.
        `InvalidSelectorException` - if the message selector is invalid.

    - #### createDurableSubscriber

          TopicSubscriber createDurableSubscriber(Topic topic,
                                                String name)
                                                  throws JMSException

      Creates an unshared durable subscription on the specified topic (if one does not already exist) and creates a consumer on that durable subscription. This method creates the durable subscription without a message selector and with a `noLocal` value of `false`.

      A durable subscription is used by an application which needs to receive all the messages published on a topic, including the ones published when there is no active consumer associated with it. The JMS provider retains a record of this durable subscription and ensures that all messages from the topic's publishers are retained until they are delivered to, and acknowledged by, a consumer on this durable subscription or until they have expired.

      A durable subscription will continue to accumulate messages until it is deleted using the `unsubscribe` method.

      This method may only be used with non-shared durable subscriptions. Any durable subscription created using this method will be non-shared. This means that only one active (i.e. not closed) consumer on the subscription may exist at a time. The term "consumer" here means a `TopicSubscriber`, `MessageConsumer` or `JMSConsumer` object in any client.

      An unshared durable subscription is identified by a name specified by the client and by the client identifier, which must be set. An application which subsequently wishes to create a consumer on that non-shared durable subscription must use the same client identifier.

      If an unshared durable subscription already exists with the same name and client identifier and the same topic and message selector, and there is no consumer already active (i.e. not closed) on the durable subscription, and no consumed messages from that subscription are still part of a pending transaction or are not yet acknowledged in the session, then this method creates a `TopicSubscriber` on the existing durable subscription.

      If an unshared durable subscription already exists with the same name and client identifier, and there is a consumer already active (i.e. not closed) on the durable subscription, or consumed messages from that subscription are still part of a pending transaction or are not yet acknowledged in the session, then a `JMSException` will be thrown.

      If an unshared durable subscription already exists with the same name and client identifier but a different topic, message selector or `noLocal` value has been specified, and there is no consumer already active (i.e. not closed) on the durable subscription, and no consumed messages from that subscription are still part of a pending transaction or are not yet acknowledged in the session, then the durable subscription will be deleted and a new one created.

      A shared durable subscription and an unshared durable subscription may not have the same name and client identifier. If a shared durable subscription already exists with the same name and client identifier then a `JMSException` is thrown.

      There is no restriction on durable subscriptions and shared non-durable subscriptions having the same name and clientId. Such subscriptions would be completely separate.

      This method is identical to the corresponding `createDurableConsumer` method except that it returns a `TopicSubscriber` rather than a `MessageConsumer` to represent the consumer.

      Specified by:
        `createDurableSubscriber` in interface `Session`
      Parameters:
        `topic` - the non-temporary `Topic` to subscribe to
        `name` - the name used to identify this subscription
      Throws:
        `InvalidDestinationException` - if an invalid topic is specified.
        `JMSException` -
        - if the session fails to create the non-shared durable subscription and `TopicSubscriber` due to some internal error
        - if the client identifier is unset
        - if an unshared durable subscription already exists with the same name and client identifier, and there is a consumer already active
        - if a shared durable subscription already exists with the same name and client identifier

    - #### createDurableSubscriber

          TopicSubscriber createDurableSubscriber(Topic topic,
                                                String name,
                                                String messageSelector,
                                                boolean noLocal)
                                                  throws JMSException

      Creates an unshared durable subscription on the specified topic (if one does not already exist), specifying a message selector and the `noLocal` parameter, and creates a consumer on that durable subscription.

      A durable subscription is used by an application which needs to receive all the messages published on a topic, including the ones published when there is no active consumer associated with it. The JMS provider retains a record of this durable subscription and ensures that all messages from the topic's publishers are retained until they are delivered to, and acknowledged by, a consumer on this durable subscription or until they have expired.

      A durable subscription will continue to accumulate messages until it is deleted using the `unsubscribe` method.

      This method may only be used with non-shared durable subscriptions. Any durable subscription created using this method will be non-shared. This means that only one active (i.e. not closed) consumer on the subscription may exist at a time. The term "consumer" here means a `TopicSubscriber`, `MessageConsumer` or `JMSConsumer` object in any client.

      An unshared durable subscription is identified by a name specified by the client and by the client identifier, which must be set. An application which subsequently wishes to create a consumer on that non-shared durable subscription must use the same client identifier.

      If an unshared durable subscription already exists with the same name and client identifier and the same topic and message selector, and there is no consumer already active (i.e. not closed) on the durable subscription, and no consumed messages from that subscription are still part of a pending transaction or are not yet acknowledged in the session, then this method creates a `TopicSubscriber` on the existing durable subscription.

      If an unshared durable subscription already exists with the same name and client identifier, and there is a consumer already active (i.e. not closed) on the durable subscription, or consumed messages from that subscription are still part of a pending transaction or are not yet acknowledged in the session, then a `JMSException` will be thrown.

      If an unshared durable subscription already exists with the same name and client identifier but a different topic, message selector or `noLocal` value has been specified, and there is no consumer already active (i.e. not closed) on the durable subscription, and no consumed messages from that subscription are still part of a pending transaction or are not yet acknowledged in the session, then the durable subscription will be deleted and a new one created.

      A shared durable subscription and an unshared durable subscription may not have the same name and client identifier. If a shared durable subscription already exists with the same name and client identifier then a `JMSException` is thrown.

      If `noLocal` is set to true then any messages published to the topic using this session's connection, or any other connection with the same client identifier, will not be added to the durable subscription.

      There is no restriction on durable subscriptions and shared non-durable subscriptions having the same name and clientId. Such subscriptions would be completely separate.

      This method is identical to the corresponding `createDurableConsumer` method except that it returns a `TopicSubscriber` rather than a `MessageConsumer` to represent the consumer.

      Specified by:
        `createDurableSubscriber` in interface `Session`
      Parameters:
        `topic` - the non-temporary `Topic` to subscribe to
        `name` - the name used to identify this subscription
        `messageSelector` - only messages with properties matching the message selector expression are added to the durable subscription. A value of null or an empty string indicates that there is no message selector for the durable subscription.
        `noLocal` - if true then any messages published to the topic using this session's connection, or any other connection with the same client identifier, will not be added to the durable subscription.
      Throws:
        `InvalidDestinationException` - if an invalid topic is specified.
        `InvalidSelectorException` - if the message selector is invalid.
        `JMSException` -
        - if the session fails to create the non-shared durable subscription and `TopicSubscriber` due to some internal error
        - if the client identifier is unset
        - if an unshared durable subscription already exists with the same name and client identifier, and there is a consumer already active
        - if a shared durable subscription already exists with the same name and client identifier

    - #### createPublisher

          TopicPublisher createPublisher(Topic topic)
                                         throws JMSException

      Creates a publisher for the specified topic.

      A client uses a `TopicPublisher` object to publish messages on a topic. Each time a client creates a `TopicPublisher` on a topic, it defines a new sequence of messages that have no ordering relationship with the messages it has previously sent.

      Parameters:
        `topic` - the `Topic` to publish to, or null if this is an unidentified producer
      Throws:
        `JMSException` - if the session fails to create a publisher due to some internal error.
        `InvalidDestinationException` - if an invalid topic is specified.

    - #### createTemporaryTopic

          TemporaryTopic createTemporaryTopic()
                                              throws JMSException

      Creates a `TemporaryTopic` object. Its lifetime will be that of the `TopicConnection` unless it is deleted earlier.
      Specified by:
        `createTemporaryTopic` in interface `Session`
      Returns:
        a temporary topic identity
      Throws:
        `JMSException` - if the session fails to create a temporary topic due to some internal error.

    - #### unsubscribe

          void unsubscribe(String name)
                           throws JMSException

      Unsubscribes a durable subscription that has been created by a client.

      This method deletes the state being maintained on behalf of the subscriber by its provider.

      It is erroneous for a client to delete a durable subscription while there is an active `TopicSubscriber` for the subscription, or while a consumed message is part of a pending transaction or has not been acknowledged in the session.

      Specified by:
        `unsubscribe` in interface `Session`
      Parameters:
        `name` - the name used to identify this subscription
      Throws:
        `JMSException` - if the session fails to unsubscribe to the durable subscription due to some internal error.
        `InvalidDestinationException` - if an invalid subscription name is specified.

Copyright (c) 2014, Oracle and/or its affiliates. All rights reserved.